defmodule DecentralisedBookIndex.Sync.DBIServerSync do
  alias DecentralisedBookIndex.Metadata
  alias DecentralisedBookIndex.Metadata.DBIServer

  def create_update(attrs, server_id) do
    case Metadata.get_dbi_server_by_id(attrs.id) do
      {:ok, dbi_server} ->
        attrs =
          attrs
          |> Map.delete(:id)
          |> Map.put(:dbi_server_id, server_id)

        dbi_server
        |> Ash.Changeset.for_update(:sync, attrs)
        |> Ash.update!(authorize?: false)

        :ok

      {:error, %Ash.Error.Query.NotFound{}} ->
        attrs =
          attrs
          |> Map.put(:dbi_server_id, server_id)

	DBIServer
        |> Ash.Changeset.for_create(:sync_create, attrs)
        |> Ash.create!(authorize?: false)

        :ok
    end
  end
end
