defmodule DecentralisedBookIndexWeb.Plugs.RequireAdmin do
  import Plug.Conn
  import Phoenix.Controller

  alias DecentralisedBookIndex.Accounts.Role

  def init(default), do: default

  def call(conn, _opts) do
    current_user = conn.assigns[:current_user]

    if current_user && Role.can_administrate?(current_user.role) do
      conn
    else
      conn
      |> put_flash(:error, "Unauthorized!")
      |> redirect(to: "/")
      |> halt()
    end
  end
end
