defmodule DecentralisedBookIndex.Repo.Migrations.UpdateBookToAddPublishedLanguageFormatAndPageCount do
  @moduledoc """
  Updates resources based on their most recent snapshots.

  This file was autogenerated with `mix ash_postgres.generate_migrations`
  """

  use Ecto.Migration

  def up do
    alter table(:books) do
      add :published, :date, null: false
      add :language, :text, null: false
      add :format, :text, null: false
      add :page_count, :bigint, null: false
    end
  end

  def down do
    alter table(:books) do
      remove :page_count
      remove :format
      remove :language
      remove :published
    end
  end
end
