defmodule DecentralisedBookIndex.SyncTasks.SyncAuthorsTaskTest do
  use DecentralisedBookIndex.DataCase

  alias DecentralisedBookIndex.SyncTasks.SyncAuthorsTask
  alias DecentralisedBookIndex.Metadata

  alias DecentralisedBookIndex.TestEndpoints
  @test_server_endpoint TestEndpoints.test_api_endpoint()

  setup do
    user = generate(user(role: :moderator))
    %{user: user}
  end

  describe "sync authors tasks" do
    test "sync authors", %{user: user} do
      server = generate(dbi_server(url: @test_server_endpoint))

      {:ok, _author} = Metadata.create_author("Author", "An description", nil, nil, actor: user)
      {:ok, _author} = Metadata.create_author("Author2", "An description", nil, nil, actor: user)

      assert ^server = SyncAuthorsTask.sync(server)
    end
  end
end
